#!/bin/bash
pushd ~

sudo apt-get install libnova-dev libcfitsio3-dev libusb-1.0-0-dev zlib1g-dev libgsl0-dev build-essential cmake git libjpeg-dev libcurl4-gnutls-dev

INDI_TEST_DIR=~/indi_16bit_test

mkdir -p $INDI_TEST_DIR
cd $INDI_TEST_DIR
git clone https://github.com/indilib/indi.git
REPO_DIR=$INDI_TEST_DIR/indi

#build libindi
mkdir -p $INDI_TEST_DIR/out
mkdir -p $INDI_TEST_DIR/udev-rules
mkdir -p $INDI_TEST_DIR/build/libindi
cd $INDI_TEST_DIR/build/libindi
cmake -F 	-DUDEVRULES_INSTALL_DIR=$INDI_TEST_DIR/udev-rules -DCMAKE_INSTALL_PREFIX=$INDI_TEST_DIR/out . $REPO_DIR/libindi
make -j8
make install

#build asi for each version
for commit in 02030b836576c0f5684d6d562737ad05b1eb1e63 64a529e31fa9e813f2c01696366323aa2062ef30 75f72cfb8c372236dfa9eef8b81bed5089e72979 690506af44c8d02bb28409a1103053942de088d1 6ffcf202ae4d0355ed2ef6ec52c2336a4da619e0 6b9fb46cc202b0bcd03a2f5fd1f3a21a43f1d65d; do
  mkdir -p $INDI_TEST_DIR/build/$commit
  #manipulate git to have the right firmware_version
  cd $REPO_DIR/3rdparty/indi-asi/armv7
  git checkout $commit libASICamera2.bin 
  cd $INDI_TEST_DIR/build/$commit
  cmake -F -D_INDI_LIB_RELEASE_driver=$INDI_TEST_DIR/out/lib/libindidriver.so -D_INDI_LIB_RELEASE_align=$INDI_TEST_DIR/out/lib/libindiAlignmentDriver.so -DINDI_INCLUDE_DIR=$INDI_TEST_DIR/out/include/libindi -DCMAKE_INSTALL_PREFIX=$INDI_TEST_DIR/out . $REPO_DIR/3rdparty/indi-asi
  echo   cmake -F -D_INDI_LIB_RELEASE_driver=$INDI_TEST_DIR/out/lib/libindidriver.so -D_INDI_LIB_RELEASE_align=$INDI_TEST_DIR/out/lib/libindiAlignmentDriver.so -DINDI_INCLUDE_DIR=$INDI_TEST_DIR/out/include/libindi -DCMAKE_INSTALL_PREFIX=$INDI_TEST_DIR/out . $REPO_DIR/3rdparty/indi-asi
  make -j8
  cp indi_asi_ccd $INDI_TEST_DIR/out/bin/indi_asi_ccd_$commit
done;


popd
